!===========================================================
MODULE ACTPol_like

  use Options
  use ACTPol_d156
  use Fg_subroutines
  use Foregrounds_loading

  implicit none
contains

 ! =======================================================================
  SUBROUTINE ACTPol_likelihood_init
     
    print*, 'Initializing ACTPol likelihood'
    call fg_init
    call actpol_d156_likelihood_init

  END SUBROUTINE ACTPol_likelihood_init
  ! ======================================================================


  ! ======================================================================
  SUBROUTINE actpol_likelihood_compute(cell,a_tsz,a_ksz,xi,a_d,a_s,a_c,a_g,a_tps,a_ps,calt,calp,like)

    implicit none
    real(8), intent(in) :: cell(2:tt_lmax,1:nspec+1) 
    real(8), intent(in) :: a_tsz,a_ksz,xi,a_d,a_s,a_c,a_g,a_tps,a_ps,calt,calp
    real(8)  :: like1
    real(8), intent(out) :: like

    like1 = 0.d0
    like  = 0.d0

!$omp parallel sections DEFAULT(SHARED)
!$omp section
    if (use_d156 .eqv. .true.) then
       call actpol_d156_likelihood_compute(cell,a_tsz,a_ksz,xi,a_d,a_s,a_c,a_g,a_tps,a_ps,calt,calp,like1)
    end if

!$omp end parallel sections

    like= like1

  END SUBROUTINE actpol_likelihood_compute
  ! ================================================================

END MODULE ACTPol_like

