! =======================================================================================
MODULE foregrounds_loading
! =======================================================================================
  use Options
  use Fg_subroutines

  implicit none
  logical :: initialise_foregrounds=.true.
  real(8), dimension (:), allocatable :: cltsz,clksz,clsz,clszcib,clcir,clp,clc
  public :: fg_init

   contains

   ! ===================================================================================
   SUBROUTINE fg_init
   ! ===================================================================================

    implicit none
    integer  :: lun,il
    real(8)  :: dummy

    allocate(cltsz(2:lmax_win),clksz(2:lmax_win),clsz(2:lmax_win),clszcib(2:lmax_win))
    allocate(clp(2:lmax_win),clcir(2:lmax_win),clc(2:lmax_win))

    !Load tSZ template
    call get_free_lun(lun)
    open(unit=lun,file=trim(data_dir)//'Fg/cl_tsz_150_bat.dat',form='formatted',status='unknown')
    do il=2,lmax_win
       read(lun,*) dummy,cltsz(il)
    enddo
    close(lun) 
    cltsz(2:lmax_win)=cltsz(2:lmax_win)/cltsz(3000) !This normalizes the tSZ spectrum to 1 at l=3000
 
    !Load kSZ template
    call get_free_lun(lun)
    open(unit=lun,file=trim(data_dir)//'Fg/cl_ksz_bat.dat',form='formatted',status='unknown')
    do il=2,lmax_win
       read(lun,*) dummy,clksz(il)
    enddo
    close(lun)
    clksz(2:lmax_win)=clksz(2:lmax_win)/clksz(3000) !This normalizes the kSZ spectrum to 1 at l=3000


    !Combine tSZ and kSZ
    clsz(2:lmax_win)=0.d0
    clsz(2:lmax_win)=cltsz(2:lmax_win)+clksz(2:lmax_win)
    
    !Define Poisson spectrum 
    do il=2,lmax_win
       clp(il)=(il/3000.d0)**2.d0 
    enddo

    !Define Clustered cib
    do il=2,lmax_win
       clc(il)=(il*(il+1.d0)/3000.d0**2.d0)*(il/3000.d0)**(-1.2d0)
    enddo

    !Load tSZ-CIB template
    call get_free_lun(lun)
    clszcib(2:lmax_win) = 0.d0
    open(unit=lun,file=trim(data_dir)//'Fg/sz_x_cib_template.dat',form='formatted',status='unknown')
    do il=2,lmax_win-1
       read(lun,*) dummy,clszcib(il)
    enddo
    close(lun)

    !Define Cirrus template 
    do il=2,lmax_win
       clcir(il)=(il/3000.d0)**(-0.7d0)
    enddo

    initialise_foregrounds=.false.

    END SUBROUTINE fg_init 
    !=====================================================================================

END MODULE foregrounds_loading
!=========================================================================================
